//
//	Color LCD Clock リソースデータ作成
//
//	2011.5.18
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifndef WIN32
#include <stdint.h>
#endif

#ifndef uint32_t
typedef unsigned long uint32_t;
#endif

uint32_t Table[256];
char Fname[256][256];

int main(int argc, char *argv[]){
	FILE	*fp;
	char	buff[1024];
	int		i;

	memset(Table, 0, sizeof(Table));
	memset(Fname, 0, sizeof(Fname));

	fp = fopen("resource.lst", "rt");
	if (fp == NULL){
		printf("file not open : resouce.lst\n");
		return -1;
	}

	while(!feof(fp)){
		int		n;
		char	fname[256];

		buff[0] = 0;
		fgets(buff, sizeof(buff), fp);
		if (buff[0] == 0)	break;
		if (!isdigit(buff[0]))	continue;
		if (sscanf(buff, "%d = %s", &n, fname) == 2){
			if ((n >= 0)&&(n <= 255)){
				FILE	*res;
				res = fopen(fname, "rb");
				if (res != NULL){
					fseek(res, 0, SEEK_END);
					Table[n] = ftell(res);
					strcpy(Fname[n], fname);
					fclose(res);
				}
			}
		}
	}
	fclose(fp);

	fp = fopen("RESOURCE.DAT", "wb");
	if (fp == NULL){
		printf("file not write : RESOURCE.DAT\n");
		return -1;
	}
	fwrite(Table, 1, sizeof(Table), fp);
	for (i = 0; i <= 255; i++){
		if (Table[i]){
			FILE	*res;
   			unsigned char	buff[65536];
	   		int		n;
			printf("%d\t%d\t%s\n", i, Table[i], Fname[i]);
			res = fopen(Fname[i], "rb");
			if (res == NULL){
				printf("file not open : %s \n", Fname[i]);
				fclose(fp);
				return -1;
			}
			while(!feof(res)){
				n = fread(buff, 1, sizeof(buff), res);
				fwrite(buff, 1, n, fp);
			}
			fclose(res);
		}
	}
	fclose(fp);

	return 0;
}
